#ifndef __REGEXP_H
#define __REGEXP_H

#include <iostream>

using namespace std;

enum op_t
  {
    UNION,
    CONCAT,
    STAR
  };

class Regexp
{
 public:
  int is_epsilon;

  int is_letter;
  char letter;

  int is_union;
  int is_concat;
  int is_star;

  Regexp* reg1;
  Regexp* reg2;

  Regexp(); //epsilon
  Regexp(char letter);
  Regexp(op_t op, Regexp* r); //star
  Regexp(op_t op, Regexp* r1, Regexp* r2); //union, concat
};

//Pretty-printer
ostream& operator <<(ostream& sout, Regexp& reg);

//Pretty constructor
Regexp& w(char c);
Regexp& w(string s);
Regexp& operator +(Regexp& r1, Regexp& r2);
Regexp& operator *(Regexp& r1, Regexp& r2);
Regexp& star(Regexp& r);

#endif
