#include <string.h>

int next[10][8] = {
  {2, 1, 3, 1, 1, 1, 1, 4},
  {9, 1, 1, 1, 1, 1, 1, 1},
  {9, 9, 9, 9, 9, 9, 9, 9},
  {9, 1, 1, 1, 1, 1, 1, 1},
  {9, 1, 1, 1, 5, 1, 1, 1},
  {9, 1, 1, 1, 1, 6, 1, 1},
  {9, 1, 1, 1, 1, 1, 7, 1},
  {9, 1, 1, 8, 1, 1, 1, 1},
  {9, 1, 1, 1, 1, 1, 1, 1},
  {9, 9, 9, 9, 9, 9, 9, 9}
};

int token[10] = {4, 4, 3, 2, 4, 4, 4, 4, 1, 0};

extern void reset_input_flow();
extern char read_next();
extern void unread();
extern char Eof;
extern void accept(int token, char* string);
extern void error(int car_number);

int char_number;

int letter_rank(char c)
{
  if(c == ' ') return 0;
  if(c == 'a') return 1;
  if(c == 'b') return 2;
  if(c == 'e') return 3;
  if(c == 'h') return 4;
  if(c == 'i') return 5;
  if(c == 'l') return 6;
  if(c == 'w') return 7;
  error(char_number);
}

char* strchar(char c)
{
  char* result = strdup("*");
  result[0] = c;
  return result;
}

int yylex()
{
  reset_input_flow();
  int state = 0;
  char c = read_next();
  char_number = 1;
  char* yytext = strdup("");
  while(c != Eof)
    {
      int target_state = next[state][letter_rank(c)];
      if(target_state == 9)
        {
          if(token[state] == 0)
            {
              error(char_number);
              return 1;
            }
          accept(token[state],yytext);
          unread();
          yytext = strchar(c);
          target_state = 0;
        }
      else
        yytext = strcat(yytext,strchar(c));
      state = target_state;
      c = read_next();
      char_number++;
    }
    if(token[state] == 0)
      {
        error(char_number);
        return 1;
      }
    accept(token[state],yytext);
  return 0;
}
